diff -uart fltk-1.3.4-1/FL/win32.H fltk-1.3.4-1-new/FL/win32.H
--- fltk-1.3.4-1/FL/win32.H	2014-09-15 09:35:05 +0000
+++ fltk-1.3.4-1-new/FL/win32.H	2017-04-26 16:57:32 +0000
@@ -127,7 +127,7 @@
 extern FL_EXPORT HDC fl_gc;
 extern FL_EXPORT MSG fl_msg;
 extern FL_EXPORT HDC fl_GetDC(Window);
-extern FL_EXPORT HDC fl_makeDC(HBITMAP);
+extern FL_EXPORT HDC fl_makeDC(HBITMAP, int &);
 
 // off-screen pixmaps: create, destroy, draw into, copy to window
 typedef HBITMAP Fl_Offscreen;
@@ -137,7 +137,7 @@
 # define fl_begin_offscreen(b) \
    HDC _sgc=fl_gc; Window _sw=fl_window; \
    Fl_Surface_Device *_ss = Fl_Surface_Device::surface(); Fl_Display_Device::display_device()->set_current(); \
-   fl_gc=fl_makeDC(b); int _savedc = SaveDC(fl_gc); fl_window=(HWND)b; fl_push_no_clip()
+   int _savedc; fl_gc=fl_makeDC(b, _savedc); fl_window=(HWND)b; fl_push_no_clip()
 
 # define fl_end_offscreen() \
    fl_pop_clip(); RestoreDC(fl_gc, _savedc); DeleteDC(fl_gc); _ss->set_current(); fl_window=_sw; fl_gc = _sgc
diff -uart fltk-1.3.4-1/src/Fl_Double_Window.cxx fltk-1.3.4-1-new/src/Fl_Double_Window.cxx
--- fltk-1.3.4-1/src/Fl_Double_Window.cxx	2016-03-08 05:18:28 +0000
+++ fltk-1.3.4-1-new/src/Fl_Double_Window.cxx	2017-04-26 16:52:53 +0000
@@ -220,8 +220,9 @@
   return can_do;
 }
 
-HDC fl_makeDC(HBITMAP bitmap) {
+HDC fl_makeDC(HBITMAP bitmap, int & old_state) {
   HDC new_gc = CreateCompatibleDC(fl_gc);
+  old_state = SaveDC(new_gc);
   SetTextAlign(new_gc, TA_BASELINE|TA_LEFT);
   SetBkMode(new_gc, TRANSPARENT);
 #if USE_COLORMAP
@@ -448,8 +449,8 @@
     fl_clip_region(myi->region); myi->region = 0;
 #ifdef WIN32
     HDC _sgc = fl_gc;
-    fl_gc = fl_makeDC(myi->other_xid);
-    int save = SaveDC(fl_gc);
+    int save;
+    fl_gc = fl_makeDC(myi->other_xid, save);
     fl_restore_clip(); // duplicate region into new gc
     draw();
     RestoreDC(fl_gc, save);
diff -uart fltk-1.3.4-1/src/Fl_Image_Surface.cxx fltk-1.3.4-1-new/src/Fl_Image_Surface.cxx
--- fltk-1.3.4-1/src/Fl_Image_Surface.cxx	2016-02-27 15:14:42 +0000
+++ fltk-1.3.4-1-new/src/Fl_Image_Surface.cxx	2017-04-26 16:56:33 +0000
@@ -162,18 +162,17 @@
   Fl_Surface_Device::set_current();
   Fl_X::set_high_resolution( CGBitmapContextGetWidth(offscreen) > width );
 #elif defined(WIN32)
-  _sgc=fl_gc; 
+  _sgc=fl_gc;
   _sw=fl_window;
-  _ss = Fl_Surface_Device::surface(); 
+  _ss = Fl_Surface_Device::surface();
   Fl_Surface_Device::set_current();
-  fl_gc = fl_makeDC(offscreen); 
-   _savedc = SaveDC(fl_gc); 
-  fl_window=(HWND)offscreen; 
+  fl_gc = fl_makeDC(offscreen, _savedc);
+  fl_window=(HWND)offscreen;
   fl_push_no_clip();
 #else
-  pre_window = fl_window; 
-  fl_window = offscreen; 
-  previous = Fl_Surface_Device::surface(); 
+  pre_window = fl_window;
+  fl_window = offscreen;
+  previous = Fl_Surface_Device::surface();
   Fl_Surface_Device::set_current();
   fl_push_no_clip();
 #endif
diff -uart fltk-1.3.4-1/src/Fl_win32.cxx fltk-1.3.4-1-new/src/Fl_win32.cxx
--- fltk-1.3.4-1/src/Fl_win32.cxx	2016-10-14 16:35:44 +0000
+++ fltk-1.3.4-1-new/src/Fl_win32.cxx	2017-04-26 16:32:01 +0000
@@ -495,11 +495,11 @@
 public:
   Fl_Win32_At_Exit() { }
   ~Fl_Win32_At_Exit() {
+    fl_cleanup_dc_list();
     fl_free_fonts();        // do some WIN32 cleanup
     fl_cleanup_pens();
     OleUninitialize();
     fl_brush_action(1);
-    fl_cleanup_dc_list();
     // This is actually too late in the cleanup process to remove the
     // clipboard notifications, but we have no earlier hook so we try
     // to work around it anyway.
